import { LogLevel } from './LogLevel';
interface BindTarget {
    [key: string]: Function;
}
export interface UnknownFactoryLevels extends Record<Uppercase<string>, number> {
    SILENT: number;
}
export interface Factory {
    [key: string]: any;
    bindMethod: (obj: BindTarget, methodName: string) => any;
    distillLevel: (level: number | string) => any;
    levelValid: (level: number | string) => boolean;
    levels: UnknownFactoryLevels;
    logger: LogLevel;
    make: (methodName: string) => Function;
    methods?: string[];
    replaceMethods: (logLevel: number | string) => void;
}
declare const BaseLevels: {
    TRACE: number;
    DEBUG: number;
    INFO: number;
    WARN: number;
    ERROR: number;
    SILENT: number;
};
export declare type MethodFactoryLevels = Lowercase<keyof typeof BaseLevels>;
export declare class MethodFactory implements Factory {
    constructor(logger?: LogLevel);
    get levels(): typeof BaseLevels;
    get logger(): LogLevel;
    set logger(logger: LogLevel);
    get methods(): string[];
    bindMethod(obj: BindTarget, methodName: string): any;
    distillLevel(level: number | string): string | number | null;
    levelValid(level: number | string): boolean;
    make(methodName: string): Function;
    replaceMethods(logLevel: number | string): void;
}
export {};
